<?php

class Factory {

	private static $_unsecuredFactory = null;

	private static $_securedFactory = null;


	public function __construct() {
		throw new Exception("Oops! Static only class.");
	}


	public static function getInstance() {

		/* oops. we are in the process space. */
		if (Security::isEnabled()) {

			/* must instatiate it */
			if (is_null(self::$_securedFactory))
				self::$_securedFactory = new ProcessFactory();

			$args = func_get_args();
			call_user_func_array(array(self::$_securedFactory, "getInstance"), $args);

		}
		/* regular module space */
		else {

			/* must instatiate it */
			if (is_null(self::$_unsecuredFactory))
				self::$_unsecuredFactory = new WorkflowFactory();

			$args = func_get_args();
			call_user_func_array(array(self::$_unsecuredFactory, "getInstance"), $args);
		}

	}

	public static function newInstance() {

	}
}

?>
